package week13;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class LogReader {
    public static boolean suspicious(String line) {
        return line.contains("Failed password");
    }
    public static void main(String[] args)
            throws MalformedURLException, IOException {
        URL logfile = new URL(
                "http://ilzd.org/teaching/2011spring/csc130/data/auth.log");
        Scanner scan = new Scanner(logfile.openStream());
        // set of unique IP addresses
        Set<String> ips = new HashSet<String>();
        // counts of number of times each IP address appears
        Map<String, Integer> ipCount = new HashMap<String, Integer>();
        while (scan.hasNext()) {
            // Find lines that are logging a break-in attempt
            String line = scan.nextLine();
            if (suspicious(line)) {
                // Get IP address from line:
                int start = line.indexOf("from") + 5;
                int end = line.indexOf(' ', start);
                String ip = line.substring(start, end);

                ips.add(ip); // add to set
                // Increment count for ip
                if (ipCount.containsKey(ip)) {
                    ipCount.put(ip, ipCount.get(ip) + 1);
                } else {
                    ipCount.put(ip, 1);
                }
            }
        }
        // for (String ip : ips) {
            // System.out.println(ip);
        // }
        for (String ip : ipCount.keySet())
            System.out.format("%15s %3s\n", ip, ipCount.get(ip));
    }

}
